unit sent;


{$optimization off}

{$F+} { Force FAR calls }
{$P-} { Turn open parameters OFF }
{$V-} { Turn OFF strict string parameter checking }
{$H-}


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spromeps;

type EAddrMismatch=class(Exception);


type
  TForm1 = class(TForm)
    InitBtn: TButton;
    ReadBtn: TButton;
    WriteBtn: TButton;
    QryBtn: TButton;
    ProcTest: TButton;
    procedure InitBtnClick(Sender: TObject);
    procedure ReadBtnClick(Sender: TObject);
    procedure WriteBtnClick(Sender: TObject);
    procedure QryBtnClick(Sender: TObject);
    procedure ProcTestClick(Sender: TObject);
  private
    { Private declarations }
  public
    function StatusDesc(status: WORD): string;
    { Public declarations }
  end;

var
  Form1: TForm1;
  thePacket : RB_SPRO_APIPACKET;
implementation
const DevId=$6F00;  //sem si dosadte svoje Developer ID
const WritePW=$AAF0; //.. a WritePassword

{$R *.DFM}




function TForm1.StatusDesc(status: WORD): string;
begin
   case (status and $FF) of
       SP_SUCCESS                  : result := '0 - Success';
       SP_INVALID_FUNCTION_CODE    : result := '1 - Invalid Function Code';
       SP_INVALID_PACKET           : result := '2 - Invalid Packet';
       SP_UNIT_NOT_FOUND           : result := '3 - Unit Not Found';
       SP_ACCESS_DENIED            : result := '4 - Access Denied';
       SP_INVALID_MEMORY_ADDRESS   : result := '5 - Invalid Memory Address';
       SP_INVALID_ACCESS_CODE      : result := '6 - Invalid Access Code';
       SP_PORT_IS_BUSY             : result := '7 - Port Is Busy';
       SP_WRITE_NOT_READY          : result := '8 - Write Not Ready';
       SP_NO_PORT_FOUND            : result := '9 - No Port Found';
       SP_ALREADY_ZERO             : result := '10 - Already Zero';
       SP_DRIVER_OPEN_ERROR        : result := '11 - Error Opening the Driver';
       SP_DRIVER_NOT_INSTALLED     : result := '12 - System Driver Not Installed';
       SP_IO_COMMUNICATIONS_ERROR  : result := '13 - Communiction Error';
       SP_PACKET_TOO_SMALL         : result := '15 - Packet Size Too Small';
       SP_INVALID_PARAMETER        : result := '16 - Invalid Parameter';
       SP_MEM_ACCESS_ERROR         : result := '17 - Error Accessing Memory';
       SP_VERSION_NOT_SUPPORTED    : result := '18 - Invalid Driver Version';
       SP_OS_NOT_SUPPORTED         : result := '19 - Invalid Operating System';
       SP_QUERY_TOO_LONG           : result := '20 - Query String Too Long';
       SP_INVALID_COMMAND          : result := '21 - Invalid Command';
       SP_MEM_ALIGNMENT_ERROR      : result := '29 - Memory Allignment Error';
       SP_DRIVER_IS_BUSY           : result := '30 - Driver is Busy';
       SP_PORT_ALLOCATION_FAILURE  : result := '31 - Cannot Allocate Port';
       SP_PORT_RELEASE_FAILURE     : result := '32 - Canot Deallocate Port';
       SP_ACQUIRE_PORT_TIMEOUT     : result := '39 - Timed out Wating for Port';
       SP_SIGNAL_NOT_SUPPORTED     : result := '42 - Signal Not Supported';
       SP_UNKNOWN_MACHINE          : result := '44 - Machine Type Unknown';
       SP_SYS_API_ERROR            : result := '45 - System API Error';
       SP_UNIT_IS_BUSY             : result := '46 - Unit Busy';
       SP_INVALID_PORT_TYPE        : result := '47 - Invalid Port Type';
       SP_INVALID_MACH_TYPE        : result := '48 - Invalid Machine Type';
       SP_INVALID_IRQ_MASK         : result := '49 - Invalid IRQ Mask';
       SP_INVALID_CONT_METHOD      : result := '50 - Contention Method Invalid';
       SP_INVALID_PORT_FLAGS       : result := '51 - Invalid Port Flags';
       SP_INVALID_OS_TYPE          : result := '53 - Invalid OS Type';
       SP_INVALID_ROUTER_FLGS      : result := '56 - Invalid Router Flags';
       SP_INIT_NOT_CALLED          : result := '57 - Must Call Init First';
       SP_DRVR_TYPE_NOT_SUPPORTED  : result := '58 - Dirver Type Invalid';
       SP_FAIL_ON_DRIVER_COMM      : result := '59 - Driver Communication Failed ';
   else
       result := IntToStr(status and $FF) + ' - Internal Error';
   end;
end;

function GetDriverString(drv:word):string;
begin
  case drv of
  1 : result:='DOS local driver.';
  2 : result:='Windows 3.x local driver.';
  3 : result:='Windows Win32s local driver.';
  4 : result:='Windows 3.x system driver.';
  5 : result:='Windows NT system driver.';
  6 : result:='OS/2 system driver.';
  7 : result:='Windows 95 system driver.';
  8 : result:='Netware local driver.';
  9 : result:='QNX local driver.';
  end;//case
end;



FUNCTION MakeHexChar (num : BYTE) : CHAR;

VAR
  offset : WORD;

BEGIN

  IF num < 10 THEN
    offset := ORD ('0') + num
  ELSE
    IF num <= 15 THEN
      offset := ORD ('A') + num - 10
    ELSE
      offset := ORD ('F');

  MakeHexChar := CHR (offset);
END; { MakeHexChar }



{Procedure       : HexCharToDigit
Purpose         : To convert a hex character to a digit
Inputs          : Hex character

Outputs         : digit between 0 and 15

Description     : Convert the character to it's numeric equivalent

                  Note: There is no check on the specified character.  Any
                  invalid hex character will return a value of 0.

******************************************************************************}
FUNCTION HexCharToDigit (hexChar : CHAR) : BYTE;

VAR
  digit : BYTE;

BEGIN

  CASE UpCase (hexChar) OF
    '0'..'9' : digit := ORD (hexChar) - ORD ('0');
    'A'..'F' : digit := ( ORD (hexChar) - ORD ('A') ) + 10;
  ELSE
    digit := 0;
  END; { CASE }

  HexCharToDigit := digit;
END; { HexCharToDigit }



{******************************************************************************
Procedure       : ConvertQueryStr

Purpose         : To convert the query string to a real query string

Inputs          : Query string

Outputs         : Real query string

Description     : The query string is entered as hex characters.
                  The real query string combines each 2 hex characters into one
                    byte.

                  Note: The query string must be an even number of bytes.
******************************************************************************}

PROCEDURE ConvertQueryStr (queryStr : STRING; VAR realQueryStr : STRING);

VAR
  i, stop, num : WORD;
  digit : BYTE;

BEGIN

  i := 1;
  realQueryStr := '';
  stop := Length (queryStr);
  WHILE i < stop DO BEGIN
    digit := HexCharToDigit (queryStr [i]);
    num := digit;
    { the first char is the high order hex byte }
    num := num shl 4;
    Inc (i);
    digit := HexCharToDigit (queryStr [i]);
    { add the low order byte }
    num := num + digit;
    Inc (i);
    realQueryStr := realQueryStr + CHR (num);
  END; { WHILE }

END; { ConvertQueryStr }
{******************************************************************************
Procedure       : ConvertResponseStr

Purpose         : To query an algorithm word

Inputs          : Response string

Outputs         : Display response string

Description     : Each character in the response string will be converted to
                    2 hex characters for display

                  Note: The display response string should be twice as large as
                  the length of the response string.
******************************************************************************}
PROCEDURE ConvertResponseStr (responseStr : STRING; VAR disResponseStr : STRING);

VAR
  i, stop: WORD;
  digit : BYTE;

BEGIN

  i := 1;
  disResponseStr := '';
  stop := Length (responseStr);

  WHILE i <= stop DO BEGIN
     { get the hi order hex digit }
     digit := ORD (responseStr [i]);
     digit := digit shr 4;
     disResponseStr := disResponseStr + MakeHexChar (digit);
     { get the lo order hex digit }
     digit := ORD (responseStr [i]);
     digit := digit AND $0F;
     disResponseStr := disResponseStr + MakeHexChar (digit);
     Inc (i);
  END; { WHILE }

END; { ConvertResponseStr }



procedure TForm1.InitBtnClick(Sender: TObject);
var error:integer;
majVer,minVer,revision,OSDriver: byte;
ffUnit:integer;
drv:string;
begin
  error := SproInitialize(@thePacket);
  ffUnit:=SproFindFirstUnit(@thePacket,DevId);
  SproGetVersion(@thePacket,majVer,minVer,revision,OSDriver);
  drv:=GetDriverString(OSDriver);
  Application.MessageBox(PChar('SproInitialize Status: ' + StatusDesc(error)+
  chr(13)+ 'SproFindFirstUnit: '+StatusDesc(ffUnit)+
  chr(13)+ 'Major version: '+Inttostr(majVer)+
  chr(13)+ 'Minor version: '+Inttostr(minVer)+
  chr(13)+ 'Revision: '+Inttostr(revision)+
  chr(13)+ 'Driver type: '+drv),
  'SuperPro Initialization',MB_OK OR MB_ICONINFORMATION);
end;

procedure TForm1.ReadBtnClick(Sender: TObject);
var status, data:word;
begin
  status := SproRead(@thePacket, $08, data);
  Application.MessageBox(PChar(StatusDesc(status)+
  chr(13) + 'Value: ' + IntToHex(data,2)), 'SuperPro Read',
  MB_OK OR MB_ICONINFORMATION);
end;

procedure TForm1.WriteBtnClick(Sender: TObject);
var status:word;
tmp:string;
msg:array[0..80] of char;
begin
  status := SproWrite(@thePacket, WritePW, $08, $FA,0);
  tmp:=StatusDesc(status);
  StrPCopy(msg,tmp);
   // v dosledku nastaveni prekladaca na tomto mieste nie je mozne pouzivat pretypovanie
  Application.MessageBox(Msg, 'SuperPro Write', MB_OK OR MB_ICONINFORMATION);
end;


procedure TForm1.QryBtnClick(Sender: TObject);
var
  realQueryStr,ResponseStr,disResponseStr : string[80];
  status : WORD;
  response32 : longint;
  tmp:array[0..50] of char;
begin
  ConvertQueryStr('AAFF', realQueryStr);
  status := SproQuery (@thePacket, $20, @realQueryStr[1],
                            @responseStr[1], response32,
                            Length(realQueryStr));
  SetLength(ResponseStr,Length(realQueryStr));
  ConvertResponseStr (responseStr, disResponseStr);
  StrPcopy(tmp,StatusDesc(status) + chr(13)+ 'Query Results: '+disResponseStr);
  Application.MessageBox(tmp,'SuperPro Query', MB_OK OR MB_ICONINFORMATION);
end;


procedure KillerProc;
begin
 Application.MessageBox('Hello world!','Killer Proc',MB_OK OR MB_ICONINFORMATION);
end;




procedure TForm1.ProcTestClick(Sender: TObject);
var
  realQueryStr,ResponseStr,disResponseStr : string[80];
  status : WORD;
  response32 : longint;
  Magic:integer;
  tmp:pointer;
  FinalAddr:Pointer;
  const StaticAddr=$41D53D;
begin
  InitBtnClick(Sender);
  ConvertQueryStr('AAFF', realQueryStr);
  status := SproQuery (@thePacket, $20, @realQueryStr[1],
                            @responseStr[1], response32,
                            Length(realQueryStr));
  SetLength(ResponseStr,Length(realQueryStr));
  ConvertResponseStr (responseStr, disResponseStr);
  Magic:=StrToInt('$'+ disResponseStr);
  tmp:=@KillerProc;

  asm
    mov eax,StaticAddr
    mov ebx,Magic
    add eax,ebx
    mov FinalAddr,eax
  end;
 {$ifdef kontrola}
   if tmp<>FinalAddr then raise EAddrMismatch.Create('Address mismatch!');
 {$endif}
 asm
   call FinalAddr
 end;
end;





end.
